
#include "functions.inc"

//#declare magnitude = function(V1) { pow(V1.x*V1.x + V1.y*V1.y + V1.z*V1.z,1/2) }
//#declare magnitude2 = function(vec) { vdot(vec,vec) }

// magnetic field from a conductor segment
// a = vector amp*length of segment
// b = position relitive to segment
#macro mag_segment(a,b)
	(vcross(a,b)/pow(vdot(b,b),3/2))
#end

// n segments from points a to b, strength s
#macro mag_segmentN(a,b, s,n)
	#local i = 0;
	#local le = a-b;
	#local m = s*(le)/vlength(le)/n;
	#while (i < n)
		+mag_segment(m, a-(i+0.5)*le/n)
		#declare i = i + 1;
	#end
#end

#macro mag_segmentNS(a,b, s,n)
	union {
	#local i = 0;
	#local le = a-b;
	#local m = s*(le)/vlength(le)/n;
	#while (i < n)
		cylinder {a-(i+0)*le/n,a-(i+1)*le/n,0.03 texture {pigment{White}}}
		#declare i = i + 1;
	#end
	}
#end

// a current loop of one 'Amp'
// at = point to compute field for
// axis = axis of the loop
// radius = vector from origin to loop
// segs = # of segment to divide loop into
#macro ring_magnet(at, axis, rad, segs)
	(<0,0,0>
	#local i = 0;
	#while (i < segs)
		//+ mag_segment((vaxis_rotate(rad, axis, 360*(i)/segs) - vaxis_rotate(rad, axis, 360*(i+1)/segs)),
		//	(at - vaxis_rotate(rad, axis, 360*(i+0.5)/segs)) )
		mag_segmentN(at - vaxis_rotate(rad, axis, 360*(i)/segs), at - vaxis_rotate(rad, axis, 360*(i+1)/segs), 1, 4)
		#declare i = i + 1;
	#end
	)
#end

#macro ring_magnetS(axis, rad, segs)
	union {
	#local i = 0;
	#while (i < segs)
		mag_segmentNS(<0,0,0> - vaxis_rotate(rad, axis, 360*(i)/segs), <0,0,0> - vaxis_rotate(rad, axis, 360*(i+1)/segs), 1, 4)
		#declare i = i + 1;
	#end
	}
#end

#macro filing(att, fld, dia)
	cylinder { att-fld, att+fld, dia }
#end

#macro filingpoint(att, fld, dia)
	cone { att-fld, dia att+fld, 0 }
#end

