// povray wiffleball5.pov -geometry 640x480

  #include "colors.inc"
  #include "textures.inc"
  #include "metals.inc"
  #include "math.inc"
//  #include "functions.inc"
  #include "shapes.inc"
  #include "magfunctions.inc"

  camera {
    orthographic
    up 3*y
    right 4*x

    location <2, 1, 3>
    location <2,0,2>
    //location <2,2,2>
    //location <0,0,3.3>
    look_at  <0, 0, 0>
  }
  
  #declare T_redmetal = texture { pigment { color rgbt <1, 0.54, 0.23, 0.7> } finish { F_MetalA  } }

  #declare T_plasma = texture
  {
    pigment { color rgbt <1, 1, 1, 1> }
    finish
    {
       diffuse 0
       
       
        specular 1 roughness 0.2
        //phong -0.1 phong_size 1
       //metallic 1
    }
  } // */
  
  #declare P_plasma = pigment { rgbt <0.1,0.1,0.1,0.5> }
  #declare I_plasma = interior
      { media
        { emission 0.2
          density
          { spherical density_map
            { [0 rgb <0,0,0>]//<0,3,3>]
              [0.1 rgb <0.5,5,5>]
              [1 rgb <0,5,5>]
            }
          }
        }
      }

  #declare diag = 54.735610317; //(atan(sqrt(2)/1));
/*
  #declare flatscal = 0.4;
  #declare flatscal2 = 0.5;
  #declare diagscal = 0.3;
  #declare diagscal2 = 0.3;
*/
  #declare flatscal = 1-sqrt(1/3);
  #declare flatscal2 = sqrt(2/3);
  #declare ringres = 4;
  #declare ringres2 = 8;
  #declare inner = 3;

  #macro polytorus(D1, D2, cnt)
  merge {
	#local i = 0;
	#while (i < cnt)
		sphere {vaxis_rotate(<D1,0,0>, y, 360*(i)/cnt) D2 }
		cylinder { vaxis_rotate(<D1,0,0>, y, 360*(i)/cnt) vaxis_rotate(<D1,0,0>, y, 360*(i+1)/cnt) D2 }
		#declare i = i+1;
	#end
  }
  #end

  #macro polywell(at, ringres)
	 ring_magnet(at,  x, < 1,flatscal2,0> ringres)
	+ring_magnet(at, -x, <-1,flatscal2,0> ringres)
	+ring_magnet(at,  y, <flatscal2, 1,0> ringres)
	+ring_magnet(at, -y, <flatscal2,-1,0> ringres)
	+ring_magnet(at,  z, <0,flatscal2, 1> ringres)
	+ring_magnet(at, -z, <0,flatscal2,-1> ringres)  // */
  #end
  
  #macro polywellS(ringres)
	union {
	ring_magnetS( x, < 1,flatscal2,0> ringres)
	ring_magnetS(-x, <-1,flatscal2,0> ringres)
	ring_magnetS( y, <flatscal2, 1,0> ringres)
	ring_magnetS(-y, <flatscal2,-1,0> ringres)
	ring_magnetS( z, <0,flatscal2, 1> ringres)
	ring_magnetS(-z, <0,flatscal2,-1> ringres) // */
	}
  #end
/*
  #declare wiffleball = isosurface
  {
	function { 0.5-
		// trouble with vector functions here
		vlength(polywell(<x,y,z>) )
		)
		
	}
  	contained_by { sphere{0,1.1} }
  	
  	max_gradient 10
//  	accuracy 0.01
  	accuracy 0.1
//  	open
  	max_trace 6
  	//texture{pigment{rgbt<1,0,0,0>}}
  	texture { T_plasma }
  }
*/
  #declare magrid = union
  {
    object { polytorus (flatscal2 0.1 ringres) translate y}
    object { polytorus (flatscal2 0.1 ringres) translate -y}
    object { polytorus (flatscal2 0.1 ringres) rotate z*90 translate x}
    object { polytorus (flatscal2 0.1 ringres) rotate z*90 translate -x}
    //object { polytorus (flatscal2 0.1 ringres) rotate x*90 translate z }
    object { polytorus (flatscal2 0.1 ringres) rotate x*90 translate -z }
  }


#declare vecres = 0.05; // 0.05;
  #declare vecs = union
  {
	//object { polywellS(ringres) }
	object { polywellS(ringres) scale 1/2 }
#declare i1 = -1;
#while (i1 <= 1)
	#declare i2 = -1;
	#while (i2 <= 1)
		#declare at=<i1,i2,-i1>;
		#declare field1 = polywell(at, ringres);
		#declare field2 = polywell(inner*at, ringres2)/inner;
		#declare field = (field1) - (field2); //(polywell(at)-(polywell(inner*at)));
		#declare fieldl = vlength(field);
		// calculate if point is inside magrid
		#declare OPt = <0,0,0>;
		#declare inmg = Isect(at, -at, object{magrid} , OPt);
		#declare mgdst = vlength(at-OPt);
		#if ((vlength(field) > 0.01) & (!inmg | (mgdst > 0.5)))
		//#if ((vlength(field1) > vlength(field2)) & (vlength(at)>0.5) & (!inmg | (mgdst > 0.5)))
			#if (vlength(field1) <= vlength(field2))
				sphere {at 0.025 texture{pigment{Blue}}}
			#else
				#declare field = 0.03*field/pow(fieldl, 2/3);
				filingpoint (at, -field, 0.01)
			#end
		#end
		#declare i2 = i2+vecres;
	#end
	#declare i1 = i1+vecres;
#end
	texture {pigment{color White}}
  }
/*
  #declare voluminc = 0.025;
  #declare volumlim = 0.7;
  #declare volum = merge
  {
#declare i1 = -volumlim;
#while (i1 <= volumlim)
	#declare i2 = -volumlim;
	#while (i2 <= volumlim)
		#declare i3 = -volumlim;
		#while (i3 <= volumlim)
			#declare at=<i1,i2,i3>;
			#declare field1 = polywell(at, ringres);
			#declare field2 = polywell(inner*at, ringres2);
			//#if ((vlength(field) > 2) & (vlength(at)>=0.5))
			#if ((vlength(field1) < vlength(field2)) & (vlength(at)>0.5))
				#declare field = 0.03*field/pow(fieldl, 3/4);
				sphere {at voluminc } //texture{pigment{color rgbt <1,1,1,0.9> }}}
				//light_source { at color White}
				//filingpoint (at, field, 0.02)
			#end
			#declare i3 = i3+voluminc;
		#end
		#declare i2 = i2+voluminc;
	#end
	#declare i1 = i1+voluminc;
#end
	sphere {0, 0.5}	// fill the hole
	hollow
	//texture {T_plasma}
	pigment {P_plasma}
	interior {I_plasma}
  } // */
  
  object { vecs no_shadow }
/*  object { volum no_shadow //double_illuminate
  } // */
  
  object { magrid texture {T_redmetal} double_illuminate no_shadow }
//  object { magrid texture {T_redmetal} double_illuminate no_shadow scale 1/2}
//  light_source { <4, 20, -8> color White}
  //light_source { <0,0,4> color White}
  light_source { <0,0,0> color White}
  
